import numpy as np
import cv2
import subprocess
import os


def convert_yuv(filename_yuv, filename_rgb, width=1600, height=1200, rotate=True):
    dat = np.fromfile(filename_yuv, dtype=np.uint8)
    img_raw = dat.reshape((height, width, 2))
    img = cv2.cvtColor(img_raw, cv2.COLOR_YUV2BGR_YUYV)
    if rotate:
        img = cv2.rotate(img, cv2.ROTATE_90_CLOCKWISE)
    if filename_yuv.endswith(".jpg"):
        cv2.imwrite(filename_rgb, img, [int(cv2.IMWRITE_JPEG_QUALITY), 95])
    else:
        cv2.imwrite(filename_rgb, img)


def set_tags(*filenames, make="Omnivision", model="OV2640", f_35mm=35):
    files_str = " ".join(filenames)
    cmd = "exiftool -overwrite_original -make={} -model={} -FocalLengthIn35mmFormat={} {}".format(make,
                                                                                                  model,
                                                                                                  f_35mm,
                                                                                                  files_str)
    pipe = subprocess.PIPE
    proc = subprocess.Popen(cmd, shell=True, stdin=pipe, stdout=pipe, stderr=pipe)
    proc.wait()
    err = proc.stderr.read().decode('unicode-escape')
    if err != "":
        raise RuntimeError(err)
